<script lang="ts">
async function getProducts() {
  const response = await fetch("https://fakestoreapi.com/products/");
  const data = await response.json();

  return data;
}

export default {
  mounted() {
    this.getAll();
  },
  data() {
    return {
      products: ([] as any[]),
      isLoading: true,
    };
  },
  methods: {
    async getAll() {
      const data = (await getProducts()).slice(0, 5);
      this.products = data;
      this.isLoading = false;
    }
  }
}
</script>

<template>
  <section class="products">
    <p v-if="isLoading">loading...</p>
    <h1 v-if="!isLoading">Products</h1>
    <ul v-if="!isLoading">
      <li v-for="product in products">
        <RouterLink :to="`/product/${product.id}`">{{ product.title }} - {{ product.price }}</RouterLink>
      </li>
    </ul>
    <button @click="loadMore">Load more</button>
  </section>
</template>